% (c) 2016 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(ltl2ba, [ltl2ba_init/0,c_call_ltl2ba/6]).

:- use_module(library(lists)).
:- use_module('../../src/module_information.pl').
:- use_module('../../src/debug.pl').

:- module_info(group,ltl).
:- module_info(description,'This is the interface to the LTL3BA tool for LTL ---> NBA.').

/* the C interface */
foreign_resource(ltl2ba, [cltl2ba]).
foreign(cltl2ba,c,cltl2ba(+term,+term,+term,+term,+term,-term)).

:- dynamic loaded_ltl2ba/0.
:- meta_predicate cltl2ba(+,+,+,+,+,+).

ltl2ba_init :- 
  print('Initialise LTL2BA...'), nl,
  loadfr.

loadfr :- (loaded_ltl2ba -> true
 ; (assert(loaded_ltl2ba),
    load_foreign_resource(library(ltl2ba)))
   ).

c_call_ltl2ba(LtlFormulaAsAtom,InitStateCallback,FiniteStateCallback,TransitionCallback,Verbose,Result) :-
   cltl2ba(LtlFormulaAsAtom,InitStateCallback,FiniteStateCallback,TransitionCallback,Verbose,Result).
