/*  
    Title: A Profiler for SICStus Prolog
    Author: Philip Höfges
    Heinrich-Heine-University Düsseldorf
    Lehrstuhl für Softwaretechnik und Programmiersprachen
    Prof. Dr. Michael Leuschel, Sebastian Krings
*/
:- module(preprofiler,[enable_profiling_all/1]).

:- use_module(profiler).

% here: add all modules that should be completely extended
:- use_module(test2).

%--------------------------------------------------------------------------------------
% preprofiler
%--------------------------------------------------------------------------------------

enable_profiling_all(Module) :-
    findall(X,Module:current_predicate(X),List),
    assert_them(Module,List).
assert_them(_,[]).
assert_them(Module,[Name/Arity|T]) :-
    assert(profiler:profiling_term(Module:Name/Arity,profiler:default_name)),
    assert_them(Module,T).

% here: enable all modules from above
:- enable_profiling_all(test2).