#!/bin/bash

pidfile=test.pid
outfile=ptest.out
junitxml="../../$JUNIT_DIR/0_send_user_interrupt.xml"
rm -f "$pidfile" "$outfile" "$junitxml"

function writeToJunit() {
    if [ -n "$JUNIT_DIR" ]; then
        echo "$1" > "$junitxml"
    fi
}

#echo "starting ptest"
./ptest "$pidfile" "$outfile" &
sleep 1
pid=`cat "$pidfile"`
#echo "sending signal to $pid"
./send_user_interrupt $pid
sleep 1
result=`cat $outfile`

writeToJunit '<testsuite><testcase name="send_user_interrupt" classname="user_signal" time="0.0">'

if [ "$result" = "ok" ]; then
    echo "send_user_interrupt: test passed"
else
    echo "send_user_interrupt: test failed"
    writeToJunit '    <error type="error">Sending user interrupt failed!</error>'
    kill $pid
fi
writeToJunit '</testcase></testsuite>'
if [ -z "$JUNIT_DIR" ]; then
    if [ "$result" != "ok" ]; then
        exit 1
    fi
fi
