#ifndef HASHTRIE_H_INCLUDED
#define HASHTRIE_H_INCLUDED


#include <stdint.h>

typedef struct index {
    uint16_t a;
    uint32_t b;
} index_t;

typedef struct node {
    index_t indices[32];
} tNode;

#include "shm_common.h"

typedef struct digestblock {
    char *digests;
    struct digestblock *next;
} digestBlock;

int calculate_pos(char *key, int depth);
int is_digest(tNode *node, int pos);
size_t trie_get_checked_states_count(void);
size_t trie_count_elements(void);
char *trie_iterate(size_t *blocklen);
int get_max_depth(void);
size_t teardown_hashtrie(void);
void trie_put(char digest[TRIE_HASHLEN], void *infos);
void *get(char key[TRIE_HASHLEN]);
int trie_contains(char key[TRIE_HASHLEN]);
int trie_contains_processed(char key[TRIE_HASHLEN]);
int is_checked(void *infos);

#endif
