#ifndef QUEUE_H_INCLUDED
#define QUEUE_H_INCLUDED

#include "shm_common.h"

typedef struct Cell {
    char *term;
    char *digest;
    int term_length;
    struct Cell* next; 
    long int pos;
} tCell;

#include "ring.h"

typedef struct Queue {
    tCell *first;
    tCell *last;
    int c;
    int strategy;
    ring_env *env;
} wQueue;

wQueue *init_queue(int strategy);

void print_term(tCell *t);
void enqueue(wQueue *q, char *term, int len, char digest[TRIE_HASHLEN]);
void enqueue_cell(wQueue *q, tCell *t);
tCell *dequeue(wQueue *q);
int is_empty(wQueue *q);
int q_size(wQueue *q);
void print_queue(wQueue *q);
void teardown_queue(wQueue **q);

#ifdef DEBUG
void enqueue_debug(wQueue *q, char *term, int len, char digest[TRIE_HASHLEN]);
void clear_debug(wQueue *q);
int check_debugq(wQueue *q, char digest[TRIE_HASHLEN], char *term, int len);
#endif

#endif
