
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <semaphore.h>

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
    sem_t *semap_meta   = sem_open("/hashes-semap_infos", O_CREAT, 0666, 1);
    sem_t *semap_hashes = sem_open("/hashes-semap_digests", O_CREAT, 0666, 1);
    sem_t *semap_hashwrite = sem_open("/hashes-semap_digestswrite", O_CREAT, 0666, 1);
    assert(semap_meta   != SEM_FAILED);
    assert(semap_hashes != SEM_FAILED);
    assert(semap_hashwrite != SEM_FAILED);

    sem_t *semap_nodes[32];
    char *semap_names[32];
    sem_t *semap_multiwrite[32];
    char *semap_multiwrite_names[32];
    int i;
    for (i = 0; i < 32; i++) {
        int len = strlen("/hashes-semap_nodes") + 3; // "31" + zero termination
        semap_names[i] = (char*) malloc(len);
        sprintf(semap_names[i], "/hashes-semap_nodes%d", i);
        semap_nodes[i] = sem_open(semap_names[i], O_CREAT, 0666, 1);
        assert(semap_nodes[i] != SEM_FAILED);
        len = strlen("/hashes-semap_meta") + 3;
        semap_multiwrite_names[i] = (char*) malloc(len);
        sprintf(semap_multiwrite_names[i], "/hashes-semap_meta%d", i);
        semap_multiwrite[i] = sem_open(semap_multiwrite_names[i], O_CREAT, 0666, 1);
        assert(semap_multiwrite[i] != SEM_FAILED);
    }

    int rc = sem_close(semap_meta);
    assert(rc == 0);
    rc = sem_close(semap_hashes);
    assert(rc == 0);
    for (i = 0; i < 32; i++) {
        rc = sem_close(semap_nodes[i]);
        assert(rc == 0);
        rc = sem_close(semap_multiwrite[i]);
        assert(rc == 0);
    }
    rc = sem_unlink("/hashes-semap_infos");
    assert(rc == 0);
    rc = sem_unlink("/hashes-semap_digests");
    assert(rc == 0);
    rc = sem_unlink("/hashes-semap_digestswrite");
    assert(rc == 0);
    for (i = 0; i < 32; i++) {
        rc = sem_unlink(semap_names[i]);
        assert(rc == 0);
        free(semap_names[i]);
        rc = sem_unlink(semap_multiwrite_names[i]);
        assert(rc == 0);
        free(semap_multiwrite_names[i]);
    }
    return 0;
}
