#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include "../common/hash.h"
#include "../common/hashtrie.h"
#include "../common/shm_srv.h"
#include "../common/shm_common.h"


void update_infos(unsigned char *infos, unsigned char *new_infos) {
    return;
}


void read_file(void) {
    puts("started");
    int fd = open("transitions", O_RDONLY);
    const int len = TRIE_HASHLEN + TRIE_ADDITIONAL_DATA;
    char buf[len];
    int i = 0;
    while(len == read(fd, buf, len)) {
        i++;
    //    if (i % 100000 == 0) {
    //        printf("%d transitions\n", i);
    //    }
        trie_put(buf + TRIE_HASHLEN, buf);
    }
    printf("done with %d transitions\n", i);
}

struct linked_list {
    char *content;
    struct linked_list *next;
};

struct linked_list *generate_path(char *key) {
    assert(key != NULL);
    struct linked_list *tail = malloc(sizeof(struct linked_list));
    tail->next = NULL;
    tail->content = key;

    char *current = key;
    while ((current = (char*) get(current)) != NULL) {
        struct linked_list *cell = malloc(sizeof(struct linked_list));
        cell->next = tail;
        cell->content = current;
        tail = cell;
    }
    return tail;
}

void unhex(char const src[41], char dest[20]) {
//    sscanf(src, "%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
//                dest+0, dest+1, dest+2, dest+3, dest+4, dest+5, dest+6, dest+7, dest+8, dest+9, dest+10, dest+11, dest+12, dest+13, dest+14, dest+15, dest+16, dest+17, dest+18, dest+19);
    int i;
    for (i = 0; i < TRIE_HASHLEN; i++) {
        int n;
        sscanf(src + 2*i, "%02x", &n);
        dest[i] = n;
    }
}

// TODO: parameterize logfile
int main(int argc, char *argv[]) {
    if (argc < 2) {
        puts("Usage: ./tracer <hashcode>");
        return 1;
    }
    struct semap_env *senv = create_semaphores();
    init_shm_common(senv);
    init_trie();

    read_file();

    char *readable = argv[1];
    char key[20];
    unhex(readable, key);

    char buf[41];
    print_readable_digest((unsigned char*) key, buf);
    printf("Generating trace to %s\n", buf);
    struct linked_list *path = generate_path(key);

    // teardown
    while (path != NULL) {
        print_readable_digest((unsigned char*) path->content, buf);
        puts(buf);
        struct linked_list *next = path->next;
        free(path);
        path = next;
    }

    shm_srv_cleanup(semaphores);
    shm_cleanup(1);

    return 0;
}
